<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgJshoppingAdminprice_filter extends JPlugin {

	function __construct(& $subject, $config){
		parent::__construct($subject, $config);
	}

    function onBeforeDisplayListProductsView(&$view){
        JFactory::getLanguage()->load('plg_price_filter');
		JHTML::_('behavior.calendar');
        $new_view = $view->tmp_html_filter;
		
		$price_from = JRequest::getVar('from');
		$price_to = JRequest::getVar('to');
		$start_date = JRequest::getVar('start_date');
		$end_date = JRequest::getVar('end_date');
        $available = JRequest::getVar('available');
		
        $view->tmp_html_filter = '<div class="price_filter">'.
		'<span>'.JText::_('COM_FROM').'</span>'.
		'<input min="0" type="number" name="from" style="width:50px;" value="'.$price_from.'">'.
		'<span>'.JText::_('COM_TO').'</span>'.
		'<input min="0" type="number" name="to" style="width:50px;"  value="'.$price_to.'"> '.
		'<span>'.JText::_('Date').': </span>'.
		JHTML::_('calendar', $start_date, 'start_date', 'start_date', '%Y-%m-%d', array('class'=>'inputbox', 'style'=>'width:80px')).
		' - '.
		JHTML::_('calendar', $end_date, 'end_date', 'end_date', '%Y-%m-%d', array('class'=>'inputbox', 'style'=>'width:80px')).' '.
        '<span>'.JText::_('COM_AVAILABLE').'</span>'.
        JHtml::_('select.genericlist', array('' => '- '.JText::_('JSELECT').' -', 1 => JText::_('COM_AVAILABLE'), 0 => JText::_('COM_NOT_AVAILABLE')), 'available', null, null, null, $available).
        '<div class="input-append"><button class="btn btn-default" onclick="document.adminForm.submit();">Filter</button></div>'.
		'</div>'.
		$new_view;
		
    }
    
    function onJshoppingModelProducts_getAllProductsQueryForFilterAfter(&$object, &$vars){
        $mainframe = JFactory::getApplication();
		$db = JFactory::getDbo();
        $context = "jshoping.list.admin.product";        
        $from = $mainframe->getUserStateFromRequest($context.'from', 'from', 0, 'int' );
        $to = $mainframe->getUserStateFromRequest($context.'to', 'to', 0, 'int' );
		$start_date = $mainframe->getUserStateFromRequest($context.'start_date', 'start_date', '');
        $end_date = $mainframe->getUserStateFromRequest($context.'end_date', 'end_date', '');        
        $available = $mainframe->getUserStateFromRequest($context.'available', 'available', '');		
                
        if ($from > 0){
            $vars['where'] .= " AND pr.product_price >= ".floatval($from);          
        }
        
        if ($to > 0){
            $vars['where'] .= " AND pr.product_price <= ".floatval($to);          
        }
		
		if ($start_date){
			$vars['where'] .= " AND pr.product_date_added >= '".$db->escape($start_date)."'";          
		}
        if ($end_date){
            $vars['where'] .= " AND pr.product_date_added <= '".$db->escape($end_date)."'";          
        }
		if($available != ''){
            if($available == 1){
                $vars['where'] .= " AND pr.product_quantity > '0'";
            }else if($available == 0){
                $vars['where'] .= " AND pr.product_quantity = '0'";
            }
        }
    }
    
}